<template>
  <v-container fluid class="px-10">
    <v-row>
      <v-col cols="2">
        <v-btn small text to="/home">
          <v-icon small>mdi-arrow-left</v-icon>
          Back to Home
        </v-btn>
      </v-col>
    </v-row>
    <h1>Downtime</h1>
    <v-divider class="mt-2 mb-4" />
    <v-row>
      <v-col>
        <h3>Downtime History</h3>
      </v-col>
      <v-col cols="auto" class="d-flex align-center">
        <v-btn
          id="btn-add-size"
          color="primary"
          class="ml-5"
          dark
          @click="isModalVisible.createDowntime = true"
          >Add Downtime</v-btn
        >
      </v-col>
    </v-row>
    <v-divider class="mt-2" />
    <v-row>
      <v-col>
        <v-data-table :headers="downtimeHeaders" :items="Sizes" item-key="id">
        </v-data-table>
      </v-col>
    </v-row>
    <v-dialog v-model="isModalVisible.createDowntime" max-width="600px">
      <v-card>
        <v-card-title>
          <span class="headline">Add Downtime</span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-form @submit.prevent="handleCreateDowntime">
            <row dense>
              <v-row>
                  <v-col cols="6">
                    <v-text-field
                        id="machine"
                        v-model="downtimeForm.name"
                        label="Machine"
                        required
                        outlined
                        hide-details
                    />
                </v-col>
                <v-col cols="6">
                    <v-select
                    v-model="downtimeForm.reasonCategory"
                    item-text="name"
                    item-value="id"
                    :items="reasonCategory"
                    label="Reason Category"
                    outlined
                    dense
                    :rules="required"
                    ></v-select>
                </v-col>
              </v-row>
              <v-row>
                  <v-col cols="6">
                    <v-select
                    v-model="downtimeForm.po"
                    item-text="name"
                    item-value="id"
                    :items="po"
                    label="PO"
                    outlined
                    dense
                    :rules="required"
                    ></v-select>
                </v-col>
                <v-col cols="6">
                    <v-select
                    v-model="downtimeForm.reason"
                    item-text="name"
                    item-value="id"
                    :items="reason"
                    label="Reason"
                    outlined
                    dense
                    :rules="required"
                    ></v-select>
                </v-col>
              </v-row>
              <v-row>
                  <v-col class="py-0" cols="2">Downtime Start: </v-col>
                    <v-col cols="4">
                        <v-menu
                        v-model="timeMenu1"
                        :close-on-content-click="false"
                        :nudge-right="40"
                        transition="scale-transition"
                        offset-y
                        min-width="290px"
                        >
                        <template v-slot:activator="{ on }">
                            <v-text-field
                            v-model="downtimeForm.downtimeStart"
                            prepend-icon="timer"
                            readonly
                            dense
                            outlined
                            :rules="required"
                            v-on="on"
                            ></v-text-field>
                        </template>
                        <v-time-picker
                            v-model="downtimeForm.downtimeStart"
                            format="24hr"
                            use-seconds
                            @input="timeMenu1 = false"
                        ></v-time-picker>
                        </v-menu>
                    </v-col>
                    <v-col cols="6">
                        <v-text-field
                            id="size-isi"
                            v-model="downtimeForm.duration"
                            label="duration"
                            type="number"
                            required
                            outlined
                            hide-details
                        />
                    </v-col>
              </v-row>
            </row>
            </v-form>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" text @click="isModalVisible.createDowntime = false">Cancel</v-btn>
          <v-btn id="btn-submit-size" color="primary" @click="handleCreateDowntime">Save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
// import DatePicker from '~/components/DatePicker'
export default {
//   components: { DatePicker },
//   async asyncData({ store, $axios }) {
//     const { data: Downtimes } = await $axios.get('/api/v1/downtimes')

//     return {
//       Downtimes: Downtimes.data
//     }
//   },
  data: () => ({
    isModalVisible: {
      createDowntime: false
    },
    downtimeHeaders: [
      { text: 'Machine', value: 'machine' },
      { text: 'Reason Category', value: 'reasonCategory' },
      { text: 'Reason', value: 'reason' },
      { text: 'Date & Time', value: 'dateTime' },
      { text: 'Duration', value: 'duration' }
    ],
    downtimeForm: {
      name: '',
      reasonCategory: '',
      po: '',
      reason: '',
      downtimeStart: '',
      duration: ''
    },
    selectedProduct: null
  }),
  methods: {
    formatDate(date) {
      return new Date(date).toLocaleString()
    },
    resetForm(form) {
      Object.keys(form).forEach((key) => (form[key] = ''))
    },
    handleCreateDowntime() {
    //   this.$axios
    //     .post('/api/v1/Downtimes', { ...this.downtimeForm })
    //     .then(() => {
    //       this.refreshList()
    //       this.isModalVisible.createDowntime = false
    //     })
    //     .catch(({ response: { data } }) => {
    //       this.$toast.error(data.message)
    //     })
    },
    async refreshList() {
    //   const { data: Downtimes } = await this.$axios.get('/api/v1/downtimes')
    //   this.Downtimes = Downtimes.data
    }
  }
}
</script>
